#include <sivtypes/system/entry_point.h>

class entry_point_implementation : public sivtypes::system::entry_point
{
public:
    entry_point_implementation();
    virtual ~entry_point_implementation() = default;

    void run(const std::shared_ptr<sivtypes::system::kernel>& kernel) override;
    uint64_t get_extra_thread_count() override;
    void run_extra_thread(uint64_t thread_id) override;
    void stop_extra_threads() override;

private:
    void try_loading_nonexisting_modules(const std::shared_ptr<sivtypes::system::kernel>& kernel);
    void run_message_conveyer(const std::shared_ptr<sivtypes::system::kernel>& kernel);
};
