#include "filter.h"
#include <sivtypes/messengers/receiver.h>
#include <sivtypes/messengers/message.h>
#include <sivdk/interface_handle.h>

using namespace std;
using namespace sivdk;
using namespace sivtypes::messengers;

filter_implementation::filter_implementation()
    : object(interface_handle::messengers__filter, get_interface_version())
{}

shared_ptr<receiver> filter_implementation::start_filtering(const shared_ptr<receiver>& output)
{
    class proxy : public receiver
    {
    public:
        proxy(const shared_ptr<receiver>& output)
            : object(interface_handle::messengers__receiver, get_interface_version())
            , m_output(output)
        {}
        virtual ~proxy() = default;

        void receive(const shared_ptr<message>& received) override
        {
            const auto sender = received->get_sender_name();
            if ((sender[0] == u's' || sender[0] == u'S') && (sender[1] == u'p' || sender[1] == u'P') &&
                (sender[2] == u'a' || sender[2] == u'A') && (sender[3] == u'm' || sender[3] == 'M'))
                return;

            m_output->receive(received);
        }

    private:
        const shared_ptr<receiver> m_output;
    };

    return make_shared<proxy>(output);
}

uint64_t filter_implementation::get_extra_thread_count()
{
    return 0;
}

void filter_implementation::run_extra_thread(uint64_t)
{}

void filter_implementation::stop_extra_threads()
{}
