#include "writer.h"
#include <sivtypes/text/writer.h>
#include <sivtypes/messengers/receiver.h>
#include <sivtypes/messengers/message.h>

using namespace std;
using namespace sivdk;
using namespace sivtypes::text;
using namespace sivtypes::messengers;

writer_implementation::writer_implementation()
    : object(interface_handle::messengers__writer, get_interface_version())
{}

shared_ptr<receiver> writer_implementation::start_writing(const shared_ptr<sivtypes::text::writer>& output)
{
    class proxy : public receiver
    {
    public:
        proxy(const shared_ptr<sivtypes::text::writer>& output)
            : object(interface_handle::messengers__receiver, get_interface_version())
            , m_output(output)
        {}
        virtual ~proxy() = default;

        void receive(const shared_ptr<message>& message) override
        {
            m_output->write(message->get_sender_name() + u": " + message->get_text() + u"\n");
        }

    private:
        const shared_ptr<sivtypes::text::writer> m_output;
    };

    return make_shared<proxy>(output);
}

uint64_t writer_implementation::get_extra_thread_count()
{
    return 0;
}

void writer_implementation::run_extra_thread(uint64_t)
{}

void writer_implementation::stop_extra_threads()
{}
