#include "entry_point.h"
#include <gmock/gmock.h>

using namespace sivdk;
using namespace testing;

entry_point_implementation::entry_point_implementation()
    : object(interface_handle::system__entry_point, get_interface_version())
{
    Mock::AllowLeak(this);

    EXPECT_CALL(*this, run(_)).Times(1);

    EXPECT_CALL(*this, get_extra_thread_count()).WillOnce(Return(4));
    EXPECT_CALL(*this, run_extra_thread(0)).Times(1);
    EXPECT_CALL(*this, run_extra_thread(1)).Times(1);
    EXPECT_CALL(*this, run_extra_thread(2)).Times(1);
    EXPECT_CALL(*this, run_extra_thread(3)).Times(1);
    EXPECT_CALL(*this, stop_extra_threads()).Times(1);
}
