#include "entry_point.h"
#include <sivtypes/system/kernel.h>
#include <sivtypes/system/failed_loading_dynamic_library_module.h>
#include <iostream>
#include <cstdlib>

using namespace std;
using namespace sivdk;
using namespace sivtypes::system;

entry_point_implementation::entry_point_implementation()
    : object(interface_handle::system__entry_point, get_interface_version())
{}

void entry_point_implementation::run(const shared_ptr<kernel>& kernel)
{
    try
    {
        const auto domains = kernel->get_domains();
        if (domains.size() != 1)
        {
            cerr << "Invalid domain count: " << domains.size() << endl;
            exit(1);
        }
    }
    catch (std::exception& e)
    {
        cerr << "Unexpected exception: " << e.what() << endl;
        exit(2);
    }
    catch (...)
    {
        cerr << "Unexpected exception" << endl;
        exit(3);
    }

    try
    {
        kernel->load_dynamic_library_module(u"InvalidModulePath.dll");
        cerr << "Didn't throw proper exception" << endl;
        exit(4);
    }
    catch (const failed_loading_dynamic_library_module&)
    {}
    catch (std::exception& e)
    {
        cerr << "Unexpected exception: " << e.what() << endl;
        exit(5);
    }
    catch (...)
    {
        cerr << "Unexpected exception" << endl;
        exit(6);
    }
}

uint64_t entry_point_implementation::get_extra_thread_count()
{
    return 0;
}

void entry_point_implementation::run_extra_thread(uint64_t)
{}

void entry_point_implementation::stop_extra_threads()
{}
